// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// Z O M B I E   T O R R E N T   2
// WEAPON FX RELATED THINGS
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Rolloff for ring sound
#define EAR_RING_MAXDIST				500.0

// Performs local ringing of the ears
// THIS IS A CLIENTSIDED SCRIPT, SPAWN FROM CLIENTSIDED FX

script "GrenadeRing" CLIENTSIDE
{
	int x = GetActorX(0);
	int y = GetActorY(0);
	int z = GetActorZ(0);
	
	// Get local player
	int CPN = ConsolePlayerNumber();
	
	if (!PlayerState[CPN].Alive)
		terminate;
		
	int pTID = PlayerTID(CPN);
	int pX = GetActorX(pTID);
	int pY = GetActorY(pTID);
	int pZ = GetActorZ(pTID);
	
	// How far away are we?
	int dx = pX - x >> 16; // Convert fixed point to integer
	int dy = pY - y >> 16;
	int dz = pZ - z >> 16;
	
	int d = sqrt( dx*dx + dy*dy + dz*dz );
	
	// What is it as a percent?
	int distPercent = clamp( FixedDiv(d*1.0, EAR_RING_MAXDIST), 0.0, 1.0 );
	
	// What sound should we play?
	str sound;
	int vol = 128;
	
	// Farthest
	// (We can lower volume based on distance)
	if (distPercent >= 0.66)
	{
		sound = "grenade/ringshort";
		
		if (distPercent >= 0.9)
			vol = 32;
		else if (distPercent >= 0.8)
			vol = 64;
		else if (distPercent >= 0.7)
			vol = 96;
	}
		
	// Middle
	else if (distPercent >= 0.33)
		sound = "grenade/ringmed";
		
	// Nearest (You should be dead at this point)
	else
		sound = "grenade/ringlong";
	
	// Play it
	AmbientSound(sound, vol);
}