// - - - - - - - - - - - - - - - - - - - - - - - - - 
// CONSTANTS
// - - - - - - - - - - - - - - - - - - - - - - - - - 

// How much should Doom units be scaled by to match a "meter"?
#define METER_SCALE				0.03125

#define FOREVER					0

#define MAXPLAYERS 				64

// How many perks can we store at once?
#define MAX_PERKS				64

// Maximum health
#define MAXIMUM_HEALTH			100

// What is this???
#define XHAIR_COUNT				6

// How much base damage should a headshot do?
#define HEADSHOT_DAMAGE			50

// Players receive a TID based on this
#define BASE_PLAYER_TID			1000

// Maximum number of different ammo types that a weapon can have
// Keep it somewhat reasonable
#define AMMOTYPE_COUNT			6

// Spread dampeners based on certain things
#define SPREAD_CROUCH			0.80
#define SPREAD_ADS				0.80
#define SPREAD_SEMI				0.80

#define MAX_UPGRADES 			8

// A weapon can give a max of PERKBONUS_MAX perk bonuses total
#define PERKBONUS_MAX			8

#define MAX_WEPS 				120

// Boss class to spawn on final wave
#define BOSS_CLASS				"ZombieBoss"

// If this is ever changed, it should be passed to clients
// (The last wave counts as a boss wave!)
#define MAX_WAVES				3

// Used for resetting our last weapon
#define JUNK_WEAPON				"JUNKY"

// Size of the zombie list table
#define ZLIST_SIZE				128

// STARTING IDENTIFIER FOR ZOMBIE LIST ITEM
// (This is subtracted from our actual item amount)
#define ZLIST_BASE				500

// Maximum number of spawners we can have on the map
#define MAXSPAWNERS 			64

// Maximum radius for spawners to be functional
// This might need to be changed, test this to be sure!
#define SPAWNER_RADIUS			512

// Maximum builds a spawner can have
#define SPAWNER_MAXBUILDS 		5

// Base TID to use for spawners
#define SPAWNER_BASETID			3000

// Default TID to use for boss spawner if not initialized
#define BOSS_DEF_SPAWNTID		1666

// TID to use for actual spawned boss
#define BOSS_TID				1667

// Distance to use for "cinematic" cams
#define CINE_DISTANCE			120.0

// Number of angle "attempts" for forced cine-cam spawn
#define CINE_ANGLE_CHOPS		10

// Duration in seconds for a spawner to stay
// "alive" after receiving a pulse from a nearby player
#define SPAWNER_ALIVETIME		2

// Seconds before a wave starts
#define COUNTDOWN_TIME			10

// Base zombie pool amount
#define ZOMBIEPOOL_BASE			10

// How often (in seconds) to cleanup lost zombies
#define SPAWNER_CHECKTIME		5

// Minimum and maximum time between spawning zombies
#define SPAWNER_TIMEMIN			2.0
#define SPAWNER_TIMEMAX			3.0

// Default trader time value (in seconds)
#define TRADER_DEFAULTTIME		45

// Maximum number of possible traders in array
#define MAXIMUM_TRADERS			10

// TID for the trader door
#define TID_TRADERDOOR			100

// Base TID for trader teleports
#define TID_TRADERTELE			300

// Default TID for zombies
#define TID_ZOMBIE				777

// Script numbers
#define SCRIPT_ENTERTRADER		20
#define SCRIPT_TRADERMENU		200

// For benchmarking
#define BENCHMARK_ITERATIONS	20000
#define BENCHMARK_BATCHSIZE		1000

// How frequently should we check resolution? In tics
#define RES_CHECK_INTERVAL		5

// How frequently should we wait for replication re-sends? In tics
#define REPLICATION_INTERVAL	40

// How frequently should our GameState messenger check for new players? (tics)
#define MESSENGER_INTERVAL		5

// What number should we cap trader lists off at?
#define TRADER_ITEMLIST_CAP		80

// How many items can we "store" at once in the trader?
#define TRADER_STORAGE_CAP		300

// How much should we reduce weapon price by when selling?
#define WEAPON_SELL_DAMPEN		0.70

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Compass
#define HID_COMPASS				1000
#define HID_COMPASS_X			HID_COMPASS-1
#define HID_COMPASS_TXT			HID_COMPASS-2
#define HID_COMPASS_DIST		HID_COMPASS-3

// Top-right circle
#define HID_CIRCLE_BG			201
#define HID_CIRCLE_A			200
#define HID_CIRCLE_B			199

// Pre-wave countdown
#define HID_CDOWN_TEXT			197
#define HID_CDOWN_BLOOD			198

// FIGHT!!!
#define HID_FIGHT				150
#define HID_PRESSREADY			149

// Mouse cursor
#define HID_CURSOR				4

// Black screen overlay!
#define HID_BLACKNESS			3000
#define HID_BLACKNESS_RANGE		20

// For fading overlays
#define HID_FADENESS			1

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_DEBUG_PERKS			4666

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_HUD_GRENADE			4000
#define HID_HUD_PRIMARY			HID_HUD_GRENADE + 1;
#define HID_HUD_SECONDARY		HID_HUD_GRENADE + 2;
#define HID_HUD_FIREMODE		HID_HUD_GRENADE + 3;
#define HID_HUD_PERKICON		HID_HUD_GRENADE + 4;

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_TRADER_TOOLTIP		250

#define HID_BUYMENU_BACK		251
#define HID_BUYMENU_SCROLL		300
#define HID_BUYMENU_BG			450
#define HID_BUYMENU_ITEM		400

#define HID_SELLMENU_SCROLL		600
#define HID_SELLMENU_BG			750
#define HID_SELLMENU_ITEM		700

#define HID_TRADER_EXIT			752
#define HID_TRADER_EXITTEXT		HID_TRADER_EXIT-1
#define HID_TRADER_AMMO			HID_TRADER_EXIT+1
#define HID_TRADER_ARMOR		HID_TRADER_EXIT+2
#define HID_TRADER_MONEY		HID_TRADER_EXIT+3
#define HID_TRADER_MONEYBG		HID_TRADER_EXIT+4

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// You have unbound keys!

#define HID_LOBBY_KEYBG			50
#define HID_LOBBY_KEYTEXT		HID_LOBBY_KEYBG-1

// We can overlap since trader and lobby are never open together

#define HID_LOBBY_BG			350

#define HID_LOBBY_TOPBAR		850

#define HID_LOBBY_SQUADBG		800
#define HID_LOBBY_SQUADHDR		HID_LOBBY_SQUADBG-48
#define HID_LOBBY_SQUADREADY	HID_LOBBY_SQUADBG-49
#define HID_LOBBY_SQUADBUT		HID_LOBBY_SQUADBG-50
#define HID_LOBBY_SQUADBAR		HID_LOBBY_SQUADBG-100

#define HID_LOBBY_OVERVIEW		HID_LOBBY_SQUADBG+1
#define HID_LOBBY_PERKERROR		HID_LOBBY_SQUADBG+2
#define HID_LOBBY_PERKS			HID_LOBBY_SQUADBG+3

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_OVERVIEW_BG			1100
#define HID_OVERVIEW_IMAGE		HID_OVERVIEW_BG - 1
#define HID_OVERVIEW_INFO		HID_OVERVIEW_BG - 2
#define HID_OVERVIEW_DESC		HID_OVERVIEW_BG - 3

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_PERK_BG				1200
#define HID_PERK_ICON			HID_PERK_BG-1
#define HID_PERK_TITLE			HID_PERK_BG-2
#define HID_PERK_LEVEL			HID_PERK_BG-3
#define HID_PERK_XP				HID_PERK_BG-4
#define HID_PERK_DESCRIPTION	HID_PERK_BG-5

#define HID_PERK_ITEMS			HID_PERK_DESCRIPTION-1

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define HID_MUSIC_BG			3100
#define HID_MUSIC_SONG			HID_MUSIC_BG-1
#define HID_MUSIC_ARTIST		HID_MUSIC_BG-2

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Various fire modes
str FireModeNames[99] = {
	"Semi-Automatic",
	"Fully-Automatic",
	"",
	"Blunt Melee",
	"Grenade",
	"Semi-Automatic",
	"Fully-Automatic",
	"",
	"",
	"Burst Fire",
};

// Bounties
#define BOUNTY_TYPES			4
enum BountyType
{
	BOUNTY_MAIN,					// 0
	BOUNTY_HEADSHOT,				// 1
	BOUNTY_GIB,						// 2
	BOUNTY_CRIPPLE,					// 3
	BOUNTY_BURNED,					// 4
};